searchNodes=[{"type":"module","title":"oidcc","doc":"OpenID Connect High Level Interface Setup { ok , Pid } = oidcc_provider_configuration_worker : start_link ( \#{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; , name =&gt; { local , google_config_provider } } ) . (or via a supervisor ) See oidcc_provider_configuration_worker for details Global Configuration max_clock_skew (default 0 ) - Maximum allowed clock skew for JWT exp / nbf validation","ref":"oidcc.html"},{"type":"function","title":"oidcc.client_credentials_token/4","doc":"Retrieve Client Credential Token See https://datatracker.ietf.org/doc/html/rfc6749#section-1.3.4 Examples { ok , # oidcc_token { } } = oidcc : client_credentials_token ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ scope =&gt; [ &lt;&lt; &quot;scope&quot; &gt;&gt; ] } ) .","ref":"oidcc.html#client_credentials_token/4"},{"type":"function","title":"oidcc.create_redirect_url/4","doc":"Create Auth Redirect URL Examples { ok , RedirectUri } = oidcc : create_redirect_url ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; \#{ redirect_uri : &lt;&lt; &quot;https://my.server/return&quot; } ) , %% RedirectUri = https://my.provider/auth?scope=openid&amp;response_type=code&amp;client_id=client_id&amp;redirect_uri=https%3A%2F%2Fmy.server%2Freturn","ref":"oidcc.html#create_redirect_url/4"},{"type":"function","title":"oidcc.introspect_token/5","doc":"Introspect the given access token Examples %% Get AccessToken { ok , # oidcc_token_introspection { active = True } } = oidcc : introspect_token ( AccessToken , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ } ) .","ref":"oidcc.html#introspect_token/5"},{"type":"function","title":"oidcc.jwt_profile_token/6","doc":"Retrieve JSON Web Token (JWT) Profile Token See https://datatracker.ietf.org/doc/html/rfc7523#section-4 Examples { ok , KeyJson } = file : read_file ( &quot;jwt-profile.json&quot; ) , KeyMap = jose : decode ( KeyJson ) , Key = jose_jwk : from_pem ( maps : get ( &lt;&lt; &quot;key&quot; &gt;&gt; , KeyMap ) ) , { ok , # oidcc_token { } } = oidcc_token : jwt_profile ( &lt;&lt; &quot;subject&quot; &gt;&gt; , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , Key , \#{ scope =&gt; [ &lt;&lt; &quot;scope&quot; &gt;&gt; ] , kid =&gt; maps : get ( &lt;&lt; &quot;keyId&quot; &gt;&gt; , KeyMap ) } ) .","ref":"oidcc.html#jwt_profile_token/6"},{"type":"function","title":"oidcc.refresh_token/5","doc":"Refresh Token Examples %% Get Token and wait for its expiry { ok , # oidcc_token { } } = oidcc : refresh_token ( Token , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ expected_subject =&gt; &lt;&lt; &quot; sub_from_initial_id_token &gt;&gt; } ) .","ref":"oidcc.html#refresh_token/5"},{"type":"function","title":"oidcc.retrieve_token/5","doc":"retrieve the token using the authcode received before and directly validate the result. the authcode was sent to the local endpoint by the OpenId Connect provider, using redirects Examples %% Get AuthCode from Redirect { ok , # oidcc_token { } } = oidcc : retrieve_token ( AuthCode , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ redirect_uri =&gt; &lt;&lt; &quot;https://example.com/callback&quot; &gt;&gt; } ) .","ref":"oidcc.html#retrieve_token/5"},{"type":"function","title":"oidcc.retrieve_userinfo/5","doc":"Load userinfo for the given token Examples %% Get Token { ok , \#{ &lt;&lt; &quot;sub&quot; &gt;&gt; =&gt; Sub } } = oidcc : retrieve_userinfo ( Token , provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ } ) .","ref":"oidcc.html#retrieve_userinfo/5"},{"type":"module","title":"oidcc_authorization","doc":"Functions to start an OpenID Connect Authorization","ref":"oidcc_authorization.html"},{"type":"function","title":"oidcc_authorization.create_redirect_url/2","doc":"Create Auth Redirect URL For a high level interface using oidcc_provider_configuration_worker see oidcc:create_redirect_url/4 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , { ok , RedirectUri } = oidcc_authorization : create_redirect_url ( ClientContext , \#{ redirect_uri : &lt;&lt; &quot;https://my.server/return&quot; } ) , %% RedirectUri = https://my.provider/auth?scope=openid&amp;response_type=code&amp;client_id=client_id&amp;redirect_uri=https%3A%2F%2Fmy.server%2Freturn","ref":"oidcc_authorization.html#create_redirect_url/2"},{"type":"type","title":"oidcc_authorization.error/0","doc":"","ref":"oidcc_authorization.html#t:error/0"},{"type":"type","title":"oidcc_authorization.opts/0","doc":"Configure authorization redirect url See https://openid.net/specs/openid-connect-core-1_0.html#AuthRequest Parameters scopes - list of scopes to request (defaults to [&lt;&lt;&quot;openid&quot;&gt;&gt;] ) state - state to pass to the provider nonce - nonce to pass to the provider pkce - pkce arguments to pass to the provider redirect_uri - redirect target after authorization is completed url_extension - add custom query parameters to the authorization url","ref":"oidcc_authorization.html#t:opts/0"},{"type":"type","title":"oidcc_authorization.pkce/0","doc":"Configure PKCE for authorization See https://datatracker.ietf.org/doc/html/rfc7636#section-4.3","ref":"oidcc_authorization.html#t:pkce/0"},{"type":"module","title":"oidcc_client_context","doc":"Client Configuration for authorization, token exchange and userinfo For most projects, it makes sense to use oidcc_provider_configuration_worker and the high-level interface of oidcc . In that case direct usage of this module is not needed. To use the record, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_client_context.hrl&quot; ] ) .","ref":"oidcc_client_context.html"},{"type":"function","title":"oidcc_client_context.from_configuration_worker/3","doc":"Create Client Context from a oidcc_provider_configuration_worker Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( \#{ issuer =&gt; &lt;&lt; &quot;https://login.salesforce.com&quot; &gt;&gt; } ) , { ok , # oidcc_client_context { } } = oidcc_client_context : from_configuration_worker ( Pid , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) . { ok , Pid } = oidcc_provider_configuration_worker : start_link ( \#{ issuer =&gt; &lt;&lt; &quot;https://login.salesforce.com&quot; &gt;&gt; , name =&gt; { local , salesforce_provider } } ) , { ok , # oidcc_client_context { } } = oidcc_client_context : from_configuration_worker ( salesforce_provider , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) .","ref":"oidcc_client_context.html#from_configuration_worker/3"},{"type":"function","title":"oidcc_client_context.from_manual/4","doc":"Create Client Context manually Examples { ok , Configuration } = oidcc_provider_configuration : load_configuration ( &lt;&lt; &quot;https://login.salesforce.com&quot; &gt;&gt; , [ ] ) , # oidcc_provider_configuration { jwks_uri = JwksUri } = Configuration , { ok , Jwks } = oidcc_provider_configuration : load_jwks ( JwksUri , [ ] ) . # oidcc_client_context { } = oidcc_client_context : from_manual ( Metdata , Jwks , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) .","ref":"oidcc_client_context.html#from_manual/4"},{"type":"type","title":"oidcc_client_context.error/0","doc":"","ref":"oidcc_client_context.html#t:error/0"},{"type":"type","title":"oidcc_client_context.t/0","doc":"","ref":"oidcc_client_context.html#t:t/0"},{"type":"module","title":"oidcc_http_util","doc":"HTTP Client Utilities","ref":"oidcc_http_util.html"},{"type":"type","title":"oidcc_http_util.error/0","doc":"","ref":"oidcc_http_util.html#t:error/0"},{"type":"type","title":"oidcc_http_util.http_header/0","doc":"See httpc:request/5","ref":"oidcc_http_util.html#t:http_header/0"},{"type":"type","title":"oidcc_http_util.httpc_error/0","doc":"See httpc:request/5 for additional errors","ref":"oidcc_http_util.html#t:httpc_error/0"},{"type":"type","title":"oidcc_http_util.query_params/0","doc":"See uri_string:compose_query/1","ref":"oidcc_http_util.html#t:query_params/0"},{"type":"type","title":"oidcc_http_util.request_opts/0","doc":"See httpc:request/5 Parameters timeout - timeout for request ssl - TLS config","ref":"oidcc_http_util.html#t:request_opts/0"},{"type":"type","title":"oidcc_http_util.telemetry_opts/0","doc":"","ref":"oidcc_http_util.html#t:telemetry_opts/0"},{"type":"module","title":"oidcc_jwt_util","doc":"JWT Utilities","ref":"oidcc_jwt_util.html"},{"type":"type","title":"oidcc_jwt_util.claims/0","doc":"","ref":"oidcc_jwt_util.html#t:claims/0"},{"type":"type","title":"oidcc_jwt_util.error/0","doc":"","ref":"oidcc_jwt_util.html#t:error/0"},{"type":"type","title":"oidcc_jwt_util.refresh_jwks_for_unknown_kid_fun/0","doc":"","ref":"oidcc_jwt_util.html#t:refresh_jwks_for_unknown_kid_fun/0"},{"type":"module","title":"oidcc_provider_configuration","doc":"Tooling to load and parse Openid Configuration Records To use the record, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_provider_configuration.hrl&quot; ] ) . Telemetry See 'Elixir.Oidcc.ProviderConfiguration'","ref":"oidcc_provider_configuration.html"},{"type":"function","title":"oidcc_provider_configuration.decode_configuration/1","doc":"Decode JSON into a oidcc_provider_configuration:t() record Examples { ok , { { &quot;HTTP/1.1&quot; , 200 , &quot;OK&quot; } , _ Headers , Body } } = httpc : request ( &quot;https://accounts.google.com/.well-known/openid-configuration&quot; ) , { ok , DecodedJson } = your_json_lib : decode ( Body ) , { ok , # oidcc_provider_configuration { } } = oidcc_provider_configuration : decode_configuration ( DecodedJson ) .","ref":"oidcc_provider_configuration.html#decode_configuration/1"},{"type":"function","title":"oidcc_provider_configuration.load_configuration/2","doc":"Load OpenID Configuration into a oidcc_provider_configuration:t() record Examples { ok , # oidcc_provider_configuration { } } = oidcc_provider_configuration : load_configuration ( &quot;https://accounts.google.com&quot; ) .","ref":"oidcc_provider_configuration.html#load_configuration/2"},{"type":"function","title":"oidcc_provider_configuration.load_jwks/2","doc":"Load JWKs into a jose_jwk:key() record Examples { ok , # jose_jwk { } } = oidcc_provider_configuration : load_jwks ( &quot;https://www.googleapis.com/oauth2/v3/certs&quot; ) .","ref":"oidcc_provider_configuration.html#load_jwks/2"},{"type":"type","title":"oidcc_provider_configuration.error/0","doc":"","ref":"oidcc_provider_configuration.html#t:error/0"},{"type":"type","title":"oidcc_provider_configuration.opts/0","doc":"Configure configuration loading / parsing Parameters fallback_expiry - How long to keep configuration cached if the server doesn't specify expiry request_opts - config for HTTP request","ref":"oidcc_provider_configuration.html#t:opts/0"},{"type":"type","title":"oidcc_provider_configuration.t/0","doc":"Record containing OpenID and OAuth 2.0 Configuration See https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderMetadata and https://datatracker.ietf.org/doc/html/draft-jones-oauth-discovery-01#section-4.1 All unrecognized fields are stored in extra_fields .","ref":"oidcc_provider_configuration.html#t:t/0"},{"type":"module","title":"oidcc_provider_configuration_worker","doc":"OIDC Config Provider Worker Loads and continuously refreshes the OIDC configuration and JWKs","ref":"oidcc_provider_configuration_worker.html"},{"type":"function","title":"oidcc_provider_configuration_worker.get_jwks/1","doc":"Get Parsed Jwks","ref":"oidcc_provider_configuration_worker.html#get_jwks/1"},{"type":"function","title":"oidcc_provider_configuration_worker.get_provider_configuration/1","doc":"Get Configuration","ref":"oidcc_provider_configuration_worker.html#get_provider_configuration/1"},{"type":"function","title":"oidcc_provider_configuration_worker.refresh_configuration/1","doc":"Refresh Configuration Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( \#{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; } ) . %% Later oidcc_provider_configuration_worker : refresh_configuration ( Pid ) .","ref":"oidcc_provider_configuration_worker.html#refresh_configuration/1"},{"type":"function","title":"oidcc_provider_configuration_worker.refresh_jwks/1","doc":"Refresh JWKs Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( \#{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; } ) . %% Later oidcc_provider_configuration_worker : refresh_jwks ( Pid ) .","ref":"oidcc_provider_configuration_worker.html#refresh_jwks/1"},{"type":"function","title":"oidcc_provider_configuration_worker.refresh_jwks_for_unknown_kid/2","doc":"Refresh JWKs if the provided Kid is not matching any currently loaded keys Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( \#{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; } ) . oidcc_provider_configuration_worker : refresh_jwks_for_unknown_kid ( Pid , &lt;&lt; &quot;kid&quot; &gt;&gt; ) .","ref":"oidcc_provider_configuration_worker.html#refresh_jwks_for_unknown_kid/2"},{"type":"function","title":"oidcc_provider_configuration_worker.start_link/1","doc":"Start Configuration Provider Examples { ok , Pid } = oidcc_provider_configuration_worker : start_link ( \#{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; , name =&gt; { local , google_config_provider } } ) . %% ... - behaviour ( supervisor ) . %% ... init ( _ opts ) -&gt; SupFlags = \#{ strategy =&gt; one_for_one , intensity =&gt; 1 , period =&gt; 5 } , ChildSpecs = [ \#{ id =&gt; google_config_provider , start =&gt; { oidcc_provider_configuration_worker , start_link , [ \#{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; } ] } , restart =&gt; permanent , type =&gt; worker , modules =&gt; [ oidcc_provider_configuration_worker ] } ] , { ok , { SupFlags , ChildSpecs } } .","ref":"oidcc_provider_configuration_worker.html#start_link/1"},{"type":"type","title":"oidcc_provider_configuration_worker.opts/0","doc":"","ref":"oidcc_provider_configuration_worker.html#t:opts/0"},{"type":"module","title":"oidcc_scope","doc":"OpenID Scope Utilities","ref":"oidcc_scope.html"},{"type":"function","title":"oidcc_scope.parse/1","doc":"Parse t() into scopes() Examples [ &lt;&lt; &quot;openid&quot; &gt;&gt; , &lt;&lt; &quot;profile&quot; &gt;&gt; ] = oidcc_scope : parse ( &lt;&lt; &quot;openid profile&quot; &gt;&gt; ) .","ref":"oidcc_scope.html#parse/1"},{"type":"function","title":"oidcc_scope.scopes_to_bin/1","doc":"Compose scopes() into t() Examples &lt;&lt; &quot;openid profile email&quot; &gt;&gt; = oidcc_scope : scopes_to_bin ( [ &lt;&lt; &quot;openid&quot; &gt;&gt; , profile , &quot;email&quot; ] ) .","ref":"oidcc_scope.html#scopes_to_bin/1"},{"type":"type","title":"oidcc_scope.scopes/0","doc":"","ref":"oidcc_scope.html#t:scopes/0"},{"type":"type","title":"oidcc_scope.t/0","doc":"","ref":"oidcc_scope.html#t:t/0"},{"type":"module","title":"oidcc_token","doc":"Facilitate OpenID Code/Token Exchanges Records To use the records, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_token.hrl&quot; ] ) . Telemetry See 'Elixir.Oidcc.Token'","ref":"oidcc_token.html"},{"type":"function","title":"oidcc_token.client_credentials/2","doc":"Retrieve Client Credential Token See https://datatracker.ietf.org/doc/html/rfc6749#section-1.3.4 For a high level interface using oidcc_provider_configuration_worker see oidcc:client_credentials_token/4 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , { ok , # oidcc_token { } } = oidcc_token : client_credentials ( ClientContext , \#{ scope =&gt; [ &lt;&lt; &quot;scope&quot; &gt;&gt; ] } ) .","ref":"oidcc_token.html#client_credentials/2"},{"type":"function","title":"oidcc_token.jwt_profile/4","doc":"Retrieve JSON Web Token (JWT) Profile Token See https://datatracker.ietf.org/doc/html/rfc7523#section-4 For a high level interface using oidcc_provider_configuration_worker see oidcc:jwt_profile_token/6 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , { ok , KeyJson } = file : read_file ( &quot;jwt-profile.json&quot; ) , KeyMap = jose : decode ( KeyJson ) , Key = jose_jwk : from_pem ( maps : get ( &lt;&lt; &quot;key&quot; &gt;&gt; , KeyMap ) ) , { ok , # oidcc_token { } } = oidcc_token : jwt_profile ( &lt;&lt; &quot;subject&quot; &gt;&gt; , ClientContext , Key , \#{ scope =&gt; [ &lt;&lt; &quot;scope&quot; &gt;&gt; ] , kid =&gt; maps : get ( &lt;&lt; &quot;keyId&quot; &gt;&gt; , KeyMap ) } ) .","ref":"oidcc_token.html#jwt_profile/4"},{"type":"function","title":"oidcc_token.refresh/3","doc":"Refresh Token For a high level interface using oidcc_provider_configuration_worker see oidcc:refresh_token/5 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get AuthCode from Redirect { ok , Token } = oidcc_token : retrieve ( AuthCode , ClientContext , \#{ redirect_uri =&gt; &lt;&lt; &quot;https://example.com/callback&quot; &gt;&gt; } ) . %% Later { ok , # oidcc_token { } } = oidcc_token : refresh ( Token , ClientContext , \#{ expected_subject =&gt; &lt;&lt; &quot; sub_from_initial_id_token &gt;&gt; } ) .","ref":"oidcc_token.html#refresh/3"},{"type":"function","title":"oidcc_token.retrieve/3","doc":"retrieve the token using the authcode received before and directly validate the result. the authcode was sent to the local endpoint by the OpenId Connect provider, using redirects For a high level interface using oidcc_provider_configuration_worker see oidcc:retrieve_token/5 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get AuthCode from Redirect { ok , # oidcc_token { } } = oidcc : retrieve ( AuthCode , ClientContext , \#{ redirect_uri =&gt; &lt;&lt; &quot;https://example.com/callback&quot; &gt;&gt; } ) .","ref":"oidcc_token.html#retrieve/3"},{"type":"function","title":"oidcc_token.validate_id_token/3","doc":"Validate ID Token Usually the id token is validated using retrieve/3 . If you gget the token passed from somewhere else, this function can validate it. Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get IdToken from somewhere { ok , Claims } = oidcc : validate_id_token ( IdToken , ClientContext , ExpectedNonce ) .","ref":"oidcc_token.html#validate_id_token/3"},{"type":"type","title":"oidcc_token.access/0","doc":"Access Token Wrapper Fields token - The retrieved token expires - Timestamp when token will expire","ref":"oidcc_token.html#t:access/0"},{"type":"type","title":"oidcc_token.client_credentials_opts/0","doc":"","ref":"oidcc_token.html#t:client_credentials_opts/0"},{"type":"type","title":"oidcc_token.error/0","doc":"","ref":"oidcc_token.html#t:error/0"},{"type":"type","title":"oidcc_token.id/0","doc":"","ref":"oidcc_token.html#t:id/0"},{"type":"type","title":"oidcc_token.jwt_profile_opts/0","doc":"","ref":"oidcc_token.html#t:jwt_profile_opts/0"},{"type":"type","title":"oidcc_token.pkce/0","doc":"","ref":"oidcc_token.html#t:pkce/0"},{"type":"type","title":"oidcc_token.refresh/0","doc":"Refresh Token Wrapper Fields token - The retrieved token","ref":"oidcc_token.html#t:refresh/0"},{"type":"type","title":"oidcc_token.refresh_opts/0","doc":"Options for refreshing a token See https://datatracker.ietf.org/doc/html/rfc6749#section-4.1.3 Fields scope - Scope to store with the token refresh_jwks - How to handle tokens with an unknown kid . See oidcc_jwt_util:refresh_jwks_for_unknown_kid_fun() expected_subject - sub of the original token","ref":"oidcc_token.html#t:refresh_opts/0"},{"type":"type","title":"oidcc_token.refresh_opts_no_sub/0","doc":"See refresh_opts_no_sub()","ref":"oidcc_token.html#t:refresh_opts_no_sub/0"},{"type":"type","title":"oidcc_token.retrieve_opts/0","doc":"Options for retrieving a token See https://datatracker.ietf.org/doc/html/rfc6749#section-4.1.3 Fields pkce - PKCE verification options nonce - Nonce to check scope - Scope to store with the token refresh_jwks - How to handle tokens with an unknown kid . See oidcc_jwt_util:refresh_jwks_for_unknown_kid_fun() redirect_uri - Redirect uri given to oidcc_authorization:create_redirect_url/2","ref":"oidcc_token.html#t:retrieve_opts/0"},{"type":"type","title":"oidcc_token.t/0","doc":"Token Response Wrapper Fields id - id() access - access() refresh - refresh() scope - oidcc_scope:scopes()","ref":"oidcc_token.html#t:t/0"},{"type":"module","title":"oidcc_token_introspection","doc":"OAuth Token Introspection See https://datatracker.ietf.org/doc/html/rfc7662 Records To use the records, import the definition: - include_lib ( [ &quot;oidcc/include/oidcc_token_introspection.hrl&quot; ] ) . Telemetry See 'Elixir.Oidcc.TokenIntrospection'","ref":"oidcc_token_introspection.html"},{"type":"function","title":"oidcc_token_introspection.introspect/3","doc":"Introspect the given access token For a high level interface using oidcc_provider_configuration_worker see oidcc:introspect_token/5 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get AccessToken { ok , # oidcc_token_introspection { active = True } } = oidcc_token_introspection : introspect ( AccessToken , ClientContext , \#{ } ) .","ref":"oidcc_token_introspection.html#introspect/3"},{"type":"type","title":"oidcc_token_introspection.error/0","doc":"","ref":"oidcc_token_introspection.html#t:error/0"},{"type":"type","title":"oidcc_token_introspection.opts/0","doc":"","ref":"oidcc_token_introspection.html#t:opts/0"},{"type":"type","title":"oidcc_token_introspection.t/0","doc":"Introspection Result See https://datatracker.ietf.org/doc/html/rfc7662#section-2.2","ref":"oidcc_token_introspection.html#t:t/0"},{"type":"module","title":"oidcc_userinfo","doc":"OpenID Connect Userinfo See https://openid.net/specs/openid-connect-core-1_0.html#UserInfo Telemetry See 'Elixir.Oidcc.Userinfo'","ref":"oidcc_userinfo.html"},{"type":"function","title":"oidcc_userinfo.retrieve/3","doc":"Load userinfo for the given token For a high level interface using oidcc_provider_configuration_worker see oidcc:retrieve_userinfo/5 . Examples { ok , ClientContext } = oidcc_client_context : from_configuration_worker ( provider_name , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; ) , %% Get Token { ok , \#{ &lt;&lt; &quot;sub&quot; &gt;&gt; =&gt; Sub } } = oidcc_userinfo : retrieve ( Token , ClientContext , \#{ } ) .","ref":"oidcc_userinfo.html#retrieve/3"},{"type":"type","title":"oidcc_userinfo.error/0","doc":"","ref":"oidcc_userinfo.html#t:error/0"},{"type":"type","title":"oidcc_userinfo.retrieve_opts/0","doc":"Configure userinfo request See https://openid.net/specs/openid-connect-core-1_0.html#UserInfoRequest Parameters refresh_jwks - How to handle tokens with an unknown kid . See oidcc_jwt_util:refresh_jwks_for_unknown_kid_fun() expected_subject - expected subject for the userinfo ( sub from id token)","ref":"oidcc_userinfo.html#t:retrieve_opts/0"},{"type":"type","title":"oidcc_userinfo.retrieve_opts_no_sub/0","doc":"See retrieve_opts()","ref":"oidcc_userinfo.html#t:retrieve_opts_no_sub/0"},{"type":"module","title":"Oidcc","doc":"OpenID Connect High Level Interface Setup { :ok , _pid } = Oidcc.ProviderConfiguration.Worker . start_link ( %{ issuer : &quot;https://accounts.google.com/&quot; , name : MyApp.GoogleConfigProvider } ) or via a supervisor Supervisor . init ( [ { Oidcc.ProviderConfiguration.Worker , %{ issuer : &quot;https://accounts.google.com/&quot; } } ] , strategy : :one_for_one ) Global Configuration max_clock_skew (default 0 ) - Maximum allowed clock skew for JWT exp / nbf validation","ref":"Oidcc.html"},{"type":"function","title":"Oidcc.client_credentials_token/4","doc":"Retrieve Client Credential Token See https://datatracker.ietf.org/doc/html/rfc6749#section-1.3.4 Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://erlef-test-w4a8z2.zitadel.cloud&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , % Oidcc.Token { } } = ...&gt; Oidcc . client_credentials_token ( ...&gt; pid , ...&gt; System . fetch_env! ( &quot;CLIENT_CREDENTIALS_CLIENT_ID&quot; ) , ...&gt; System . fetch_env! ( &quot;CLIENT_CREDENTIALS_CLIENT_SECRET&quot; ) , ...&gt; %{ scope : [ &quot;scope&quot; ] } ...&gt; )","ref":"Oidcc.html#client_credentials_token/4"},{"type":"function","title":"Oidcc.create_redirect_url/4","doc":"Create Auth Redirect URL Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , _redirect_uri } = ...&gt; Oidcc . create_redirect_url ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; , ...&gt; %{ redirect_uri : &quot;https://my.server/return&quot; } ...&gt; )","ref":"Oidcc.html#create_redirect_url/4"},{"type":"function","title":"Oidcc.introspect_token/5","doc":"Introspect the given access token Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; Oidcc . introspect_token ( ...&gt; &quot;access_token&quot; , ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; ...&gt; ) ...&gt; # =&gt; {:ok, %Oidcc.TokenIntrospection{}}","ref":"Oidcc.html#introspect_token/5"},{"type":"function","title":"Oidcc.jwt_profile_token/6","doc":"Retrieve JSON Web Token (JWT) Profile Token https://datatracker.ietf.org/doc/html/rfc7523#section-4 Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://erlef-test-w4a8z2.zitadel.cloud&quot; ...&gt; } ) ...&gt; ...&gt; %{ &quot;key&quot; =&gt; key , &quot;keyId&quot; =&gt; kid , &quot;userId&quot; =&gt; subject } = &quot;JWT_PROFILE&quot; ...&gt; |&gt; System . fetch_env! ( ) ...&gt; |&gt; JOSE . decode ( ) ...&gt; ...&gt; jwk = JOSE.JWK . from_pem ( key ) ...&gt; ...&gt; { :ok , % Oidcc.Token { } } = ...&gt; Oidcc . jwt_profile_token ( ...&gt; subject , ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; , ...&gt; jwk , ...&gt; %{ scope : [ &quot;urn:zitadel:iam:org:project:id:zitadel:aud&quot; ] , kid : kid } ...&gt; )","ref":"Oidcc.html#jwt_profile_token/6"},{"type":"function","title":"Oidcc.refresh_token/5","doc":"Refresh Token Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; # Get refresh_token fromm redirect ...&gt; refresh_token = &quot;refresh_token&quot; ...&gt; ...&gt; Oidcc . refresh_token ( ...&gt; refresh_token , ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; , ...&gt; %{ expected_subject : &quot;sub_from_initial_id_token&quot; } ...&gt; ) ...&gt; # =&gt; {:ok, %Oidcc.Token{}}","ref":"Oidcc.html#refresh_token/5"},{"type":"function","title":"Oidcc.retrieve_token/5","doc":"retrieve the token using the authcode received before and directly validate the result. the authcode was sent to the local endpoint by the OpenId Connect provider, using redirects Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; # Get auth_code fromm redirect ...&gt; auth_code = &quot;auth_code&quot; ...&gt; ...&gt; Oidcc . retrieve_token ( ...&gt; auth_code , ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; , ...&gt; %{ redirect_uri : &quot;https://my.server/return&quot; } ...&gt; ) ...&gt; # =&gt; {:ok, %Oidcc.Token{}}","ref":"Oidcc.html#retrieve_token/5"},{"type":"function","title":"Oidcc.retrieve_userinfo/5","doc":"Load userinfo for the given token Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; # Get access_token from Oidcc.Token.retrieve/3 ...&gt; access_token = &quot;access_token&quot; ...&gt; ...&gt; Oidcc . retrieve_userinfo ( ...&gt; access_token , ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; , ...&gt; %{ expected_subject : &quot;sub&quot; } ...&gt; ) ...&gt; # =&gt; {:ok, %{&quot;sub&quot; =&gt; &quot;sub&quot;}}","ref":"Oidcc.html#retrieve_userinfo/5"},{"type":"module","title":"Oidcc.Authorization","doc":"Functions to start an OpenID Connect Authorization","ref":"Oidcc.Authorization.html"},{"type":"function","title":"Oidcc.Authorization.create_redirect_url/2","doc":"Create Auth Redirect URL For a high level interface using Oidcc.ProviderConfiguration.Worker see Oidcc.create_redirect_url/4 . Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , client_context } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; ...&gt; ) ...&gt; ...&gt; { :ok , _redirect_uri } = ...&gt; Oidcc.Authorization . create_redirect_url ( ...&gt; client_context , ...&gt; %{ redirect_uri : &quot;https://my.server/return&quot; } ...&gt; )","ref":"Oidcc.Authorization.html#create_redirect_url/2"},{"type":"module","title":"Oidcc.ClientContext","doc":"Client Configuration for authorization, token exchange and userinfo For most projects, it makes sense to use Oidcc.ProviderConfiguration.Worker and the high-level interface of Oidcc . In that case direct usage of this module is not needed.","ref":"Oidcc.ClientContext.html"},{"type":"function","title":"Oidcc.ClientContext.from_configuration_worker/3","doc":"Create Client Context from a Oidcc.ProviderConfiguration.Worker Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; , ...&gt; name : __MODULE__ . GoogleConfigProvider ...&gt; } ) ...&gt; ...&gt; { :ok , % Oidcc.ClientContext { } } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; __MODULE__ . GoogleConfigProvider , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_Secret&quot; ...&gt; ) ...&gt; ...&gt; { :ok , % Oidcc.ClientContext { } } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_Secret&quot; ...&gt; )","ref":"Oidcc.ClientContext.html#from_configuration_worker/3"},{"type":"function","title":"Oidcc.ClientContext.from_manual/4","doc":"Create Client Context manually Examples iex&gt; { :ok , { configuration , _expiry } } = ...&gt; Oidcc.ProviderConfiguration . load_configuration ( ...&gt; &quot;https://login.salesforce.com&quot; ...&gt; ) ...&gt; ...&gt; { :ok , { jwks , _expiry } } = ...&gt; Oidcc.ProviderConfiguration . load_jwks ( ...&gt; configuration . jwks_uri ...&gt; ) ...&gt; ...&gt; % Oidcc.ClientContext { } = ...&gt; Oidcc.ClientContext . from_manual ( ...&gt; configuration , ...&gt; jwks , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_Secret&quot; ...&gt; )","ref":"Oidcc.ClientContext.html#from_manual/4"},{"type":"type","title":"Oidcc.ClientContext.t/0","doc":"","ref":"Oidcc.ClientContext.html#t:t/0"},{"type":"module","title":"Oidcc.ProviderConfiguration","doc":"Tooling to load and parse Openid Configuration Telemetry [:oidcc, :load_configuration, :start] Description: Emitted at the start of loading the provider configuration Measurements: %{system_time: non_neg_integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string()} [:oidcc, :load_configuration, :stop] Description: Emitted at the end of loading the provider configuration Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string()} [:oidcc, :load_configuration, :exception] Description: Emitted at the end of loading the provider configuration Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string()} [:oidcc, :load_jwks, :start] Description: Emitted at the start of loading the provider jwks Measurements: %{system_time: non_neg_integer(), monotonic_time: integer()} Metadata: %{jwks_uri: :uri_string.uri_string()} [:oidcc, :load_jwks, :stop] Description: Emitted at the end of loading the provider jwks Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{jwks_uri: :uri_string.uri_string()} [:oidcc, :load_jwks, :exception] Description: Emitted at the end of loading the provider jwks Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{jwks_uri: :uri_string.uri_string()}","ref":"Oidcc.ProviderConfiguration.html"},{"type":"function","title":"Oidcc.ProviderConfiguration.decode_configuration/1","doc":"Decode JSON into OpenID configuration Examples iex&gt; { :ok , { { ~c&quot;HTTP/1.1&quot; , 200 , ~c&quot;OK&quot; } , _headers , body } } = ...&gt; :httpc . request ( &quot;https://accounts.google.com/.well-known/openid-configuration&quot; ) ...&gt; ...&gt; decoded_json = body |&gt; to_string ( ) |&gt; JOSE . decode ( ) ...&gt; ...&gt; { :ok , % ProviderConfiguration { issuer : &quot;https://accounts.google.com&quot; } } = ...&gt; Oidcc.ProviderConfiguration . decode_configuration ( decoded_json )","ref":"Oidcc.ProviderConfiguration.html#decode_configuration/1"},{"type":"function","title":"Oidcc.ProviderConfiguration.load_configuration/2","doc":"Load OpenID Configuration Examples iex&gt; { :ok , { ...&gt; % ProviderConfiguration { issuer : &quot;https://accounts.google.com&quot; } , ...&gt; _expiry ...&gt; } } = Oidcc.ProviderConfiguration . load_configuration ( &quot;https://accounts.google.com&quot; )","ref":"Oidcc.ProviderConfiguration.html#load_configuration/2"},{"type":"function","title":"Oidcc.ProviderConfiguration.load_jwks/2","doc":"Load JWKs Examples iex&gt; { :ok , { % JOSE.JWK { } , _expiry } } = ...&gt; Oidcc.ProviderConfiguration . load_jwks ( &quot;https://www.googleapis.com/oauth2/v3/certs&quot; )","ref":"Oidcc.ProviderConfiguration.html#load_jwks/2"},{"type":"type","title":"Oidcc.ProviderConfiguration.t/0","doc":"Configuration Struct For details on the fields see: https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderMetadata https://datatracker.ietf.org/doc/html/draft-jones-oauth-discovery-01#section-4.1","ref":"Oidcc.ProviderConfiguration.html#t:t/0"},{"type":"module","title":"Oidcc.ProviderConfiguration.Worker","doc":"OIDC Config Provider Worker Loads and continuously refreshes the OIDC configuration and JWKs Usage in Supervisor Supervisor . init ( [ { Oidcc.ProviderConfiguration.Worker , %{ issuer : &quot;https://accounts.google.com/&quot; } } ] , strategy : :one_for_one )","ref":"Oidcc.ProviderConfiguration.Worker.html"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.child_spec/1","doc":"","ref":"Oidcc.ProviderConfiguration.Worker.html#child_spec/1"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.get_jwks/1","doc":"Get Parsed Jwks Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; ...&gt; } ) ...&gt; % JOSE.JWK { } = ...&gt; Oidcc.ProviderConfiguration.Worker . get_jwks ( pid )","ref":"Oidcc.ProviderConfiguration.Worker.html#get_jwks/1"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.get_provider_configuration/1","doc":"Get Configuration Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; ...&gt; } ) ...&gt; % Oidcc.ProviderConfiguration { issuer : &quot;https://accounts.google.com&quot; } = ...&gt; Oidcc.ProviderConfiguration.Worker . get_provider_configuration ( pid )","ref":"Oidcc.ProviderConfiguration.Worker.html#get_provider_configuration/1"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.refresh_configuration/1","doc":"Refresh Configuration Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; ...&gt; } ) ...&gt; :ok = Oidcc.ProviderConfiguration.Worker . refresh_configuration ( pid )","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_configuration/1"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.refresh_jwks/1","doc":"Refresh JWKs Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; ...&gt; } ) ...&gt; :ok = Oidcc.ProviderConfiguration.Worker . refresh_jwks ( pid )","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_jwks/1"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.refresh_jwks_for_unknown_kid/2","doc":"Refresh JWKs if the provided Kid is not matching any currently loaded keys Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; ...&gt; } ) ...&gt; :ok = Oidcc.ProviderConfiguration.Worker . refresh_jwks_for_unknown_kid ( pid , &quot;kid&quot; )","ref":"Oidcc.ProviderConfiguration.Worker.html#refresh_jwks_for_unknown_kid/2"},{"type":"function","title":"Oidcc.ProviderConfiguration.Worker.start_link/1","doc":"Start Configuration Worker Examples iex&gt; { :ok , _pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://accounts.google.com/&quot; , ...&gt; name : __MODULE__ . GoogleConfigProvider ...&gt; } )","ref":"Oidcc.ProviderConfiguration.Worker.html#start_link/1"},{"type":"type","title":"Oidcc.ProviderConfiguration.Worker.opts/0","doc":"See t:oidcc_provider_configuration_worker.opts/0","ref":"Oidcc.ProviderConfiguration.Worker.html#t:opts/0"},{"type":"module","title":"Oidcc.Token","doc":"Facilitate OpenID Code/Token Exchanges Telemetry [:oidcc, :request_token, :start] Description: Emitted at the start of requesting a code token Measurements: %{system_time: non_neg_integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :request_token, :stop] Description: Emitted at the end of requesting a code token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :request_token, :exception] Description: Emitted at the end of requesting a code token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :refresh_token, :start] Description: Emitted at the start of refreshing a token Measurements: %{system_time: non_neg_integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :refresh_token, :stop] Description: Emitted at the end of refreshing a token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :refresh_token, :exception] Description: Emitted at the end of refreshing a token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :jwt_profile_token, :start] Description: Emitted at the start of exchanging a JWT profile token Measurements: %{system_time: non_neg_integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :jwt_profile_token, :stop] Description: Emitted at the end of exchanging a JWT profile token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :jwt_profile_token, :exception] Description: Emitted at the end of exchanging a JWT profile token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :client_credentials, :start] Description: Emitted at the start of requesting a client credentials token Measurements: %{system_time: non_neg_integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :client_credentials, :stop] Description: Emitted at the end of requesting a client credentials token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :client_credentials, :exception] Description: Emitted at the end of requesting a client credentials token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()}","ref":"Oidcc.Token.html"},{"type":"function","title":"Oidcc.Token.client_credentials/2","doc":"Retrieve Client Credential Token See https://datatracker.ietf.org/doc/html/rfc6749#section-1.3.4 For a high level interface using Oidcc.ProviderConfiguration.Worker see Oidcc.client_credentials_token/4 . Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://erlef-test-w4a8z2.zitadel.cloud&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , client_context } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; System . fetch_env! ( &quot;CLIENT_CREDENTIALS_CLIENT_ID&quot; ) , ...&gt; System . fetch_env! ( &quot;CLIENT_CREDENTIALS_CLIENT_SECRET&quot; ) ...&gt; ) ...&gt; ...&gt; { :ok , % Oidcc.Token { } } = ...&gt; Oidcc.Token . client_credentials ( ...&gt; client_context , ...&gt; %{ scope : [ &quot;scope&quot; ] } ...&gt; )","ref":"Oidcc.Token.html#client_credentials/2"},{"type":"function","title":"Oidcc.Token.jwt_profile/4","doc":"Retrieve JSON Web Token (JWT) Profile Token See https://datatracker.ietf.org/doc/html/rfc7523#section-4 For a high level interface using Oidcc.ProviderConfiguration.Worker see Oidcc.jwt_profile_token/6 . Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://erlef-test-w4a8z2.zitadel.cloud&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , client_context } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; ...&gt; ) ...&gt; ...&gt; %{ &quot;key&quot; =&gt; key , &quot;keyId&quot; =&gt; kid , &quot;userId&quot; =&gt; subject } = &quot;JWT_PROFILE&quot; ...&gt; |&gt; System . fetch_env! ( ) ...&gt; |&gt; JOSE . decode ( ) ...&gt; ...&gt; jwk = JOSE.JWK . from_pem ( key ) ...&gt; ...&gt; { :ok , % Oidcc.Token { } } = ...&gt; Oidcc.Token . jwt_profile ( ...&gt; subject , ...&gt; client_context , ...&gt; jwk , ...&gt; %{ scope : [ &quot;urn:zitadel:iam:org:project:id:zitadel:aud&quot; ] , kid : kid } ...&gt; )","ref":"Oidcc.Token.html#jwt_profile/4"},{"type":"function","title":"Oidcc.Token.refresh/3","doc":"Refresh Token For a high level interface using Oidcc.ProviderConfiguration.Worker see Oidcc.refresh_token/5 . Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , client_context } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; ...&gt; ) ...&gt; ...&gt; # Get refresh_token fromm redirect ...&gt; refresh_token = &quot;refresh_token&quot; ...&gt; ...&gt; Oidcc.Token . refresh ( ...&gt; refresh_token , ...&gt; client_context , ...&gt; %{ expected_subject : &quot;sub&quot; } ...&gt; ) ...&gt; # =&gt; {:ok, %Oidcc.Token{}}","ref":"Oidcc.Token.html#refresh/3"},{"type":"function","title":"Oidcc.Token.retrieve/3","doc":"retrieve the token using the authcode received before and directly validate the result. the authcode was sent to the local endpoint by the OpenId Connect provider, using redirects For a high level interface using Oidcc.ProviderConfiguration.Worker see Oidcc.retrieve_token/5 . Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , client_context } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; ...&gt; ) ...&gt; ...&gt; # Get auth_code fromm redirect ...&gt; auth_code = &quot;auth_code&quot; ...&gt; ...&gt; Oidcc.Token . retrieve ( ...&gt; auth_code , ...&gt; client_context , ...&gt; %{ redirect_uri : &quot;https://my.server/return&quot; } ...&gt; ) ...&gt; # =&gt; {:ok, %Oidcc.Token{}}","ref":"Oidcc.Token.html#retrieve/3"},{"type":"function","title":"Oidcc.Token.validate_id_token/3","doc":"Validate ID Token Usually the id token is validated using retrieve/3 . If you get the token passed from somewhere else, this function can validate it. Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , client_context } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; ...&gt; ) ...&gt; ...&gt; #Get IdToken from somewhere ...&gt; id_token = &quot;id_token&quot; ...&gt; ...&gt; Oidcc.Token . validate_id_token ( id_token , client_context , :any ) ...&gt; # =&gt; {:ok, %{&quot;sub&quot; =&gt; &quot;sub&quot;, ... }}","ref":"Oidcc.Token.html#validate_id_token/3"},{"type":"type","title":"Oidcc.Token.t/0","doc":"","ref":"Oidcc.Token.html#t:t/0"},{"type":"module","title":"Oidcc.Token.Access","doc":"Access Token struct","ref":"Oidcc.Token.Access.html"},{"type":"type","title":"Oidcc.Token.Access.t/0","doc":"","ref":"Oidcc.Token.Access.html#t:t/0"},{"type":"module","title":"Oidcc.Token.Id","doc":"ID Token struct","ref":"Oidcc.Token.Id.html"},{"type":"type","title":"Oidcc.Token.Id.t/0","doc":"","ref":"Oidcc.Token.Id.html#t:t/0"},{"type":"module","title":"Oidcc.Token.Refresh","doc":"Refresh Token struct","ref":"Oidcc.Token.Refresh.html"},{"type":"type","title":"Oidcc.Token.Refresh.t/0","doc":"","ref":"Oidcc.Token.Refresh.html#t:t/0"},{"type":"module","title":"Oidcc.TokenIntrospection","doc":"OAuth Token Introspection See https://datatracker.ietf.org/doc/html/rfc7662 Telemetry [:oidcc, :introspect_token, :start] Description: Emitted at the start of introspecting the token Measurements: %{system_time: non_neg_integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :introspect_token, :stop] Description: Emitted at the end of introspecting the token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :introspect_token, :exception] Description: Emitted at the end of introspecting the token Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()}","ref":"Oidcc.TokenIntrospection.html"},{"type":"function","title":"Oidcc.TokenIntrospection.introspect/3","doc":"Introspect the given access token For a high level interface using Oidcc.ProviderConfiguration.Worker see Oidcc.introspect_token/5 . Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , client_context } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; ...&gt; ) ...&gt; ...&gt; Oidcc.TokenIntrospection . introspect ( ...&gt; &quot;access_token&quot; , ...&gt; client_context ...&gt; ) ...&gt; # =&gt; {:ok, %Oidcc.TokenIntrospection{}}","ref":"Oidcc.TokenIntrospection.html#introspect/3"},{"type":"type","title":"Oidcc.TokenIntrospection.t/0","doc":"","ref":"Oidcc.TokenIntrospection.html#t:t/0"},{"type":"module","title":"Oidcc.Userinfo","doc":"OpenID Connect Userinfo See https://openid.net/specs/openid-connect-core-1_0.html#UserInfo Telemetry [:oidcc, :userinfo, :start] Description: Emitted at the start of loading userinfo Measurements: %{system_time: non_neg_integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :userinfo, :stop] Description: Emitted at the end of loading userinfo Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()} [:oidcc, :userinfo, :exception] Description: Emitted at the end of loading userinfo Measurements: %{duration: integer(), monotonic_time: integer()} Metadata: %{issuer: :uri_string.uri_string(), client_id: String.t()}","ref":"Oidcc.Userinfo.html"},{"type":"function","title":"Oidcc.Userinfo.retrieve/3","doc":"Load userinfo for the given token For a high level interface using Oidcc.ProviderConfiguration.Worker see Oidcc.retrieve_userinfo/5 . Examples iex&gt; { :ok , pid } = ...&gt; Oidcc.ProviderConfiguration.Worker . start_link ( %{ ...&gt; issuer : &quot;https://login.yahoo.com&quot; ...&gt; } ) ...&gt; ...&gt; { :ok , client_context } = ...&gt; Oidcc.ClientContext . from_configuration_worker ( ...&gt; pid , ...&gt; &quot;client_id&quot; , ...&gt; &quot;client_secret&quot; ...&gt; ) ...&gt; ...&gt; # Get access_token from Oidcc.Token.retrieve/3 ...&gt; access_token = &quot;access_token&quot; ...&gt; ...&gt; Oidcc.Userinfo . retrieve ( ...&gt; access_token , ...&gt; client_context , ...&gt; %{ expected_subject : &quot;sub&quot; } ...&gt; ) ...&gt; # =&gt; {:ok, %{&quot;sub&quot; =&gt; &quot;sub&quot;}}","ref":"Oidcc.Userinfo.html#retrieve/3"},{"type":"extras","title":"oidcc","doc":"OpenID Connect client library for Erlang. The refactoring for v3 and the certification is funded as an Erlang Ecosystem Foundation stipend entered by the Security Working Group .","ref":"readme.html"},{"type":"extras","title":"oidcc - Setup","doc":"Erlang directly { ok , Pid } = oidcc_provider_configuration_worker : start_link ( \#{ issuer =&gt; &lt;&lt; &quot;https://accounts.google.com&quot; &gt;&gt; , name =&gt; { local , google_config_provider } } ) . via supervisor - behaviour ( supervisor ) . %% ... init ( _ Args ) -&gt; SupFlags = \#{ strategy =&gt; one_for_one } , ChildSpecs = [ \#{ id =&gt; oidcc_provider_configuration_worker , start =&gt; { oidcc_provider_configuration_worker , start_link , [ \#{ issuer =&gt; &quot;https://accounts.google.com&quot; , name =&gt; { local , myapp_oidcc_config_provider } } ] } , shutdown =&gt; brutal_kill } ] , { ok , { SupFlags , ChildSpecs } } . Elixir directly { :ok , _pid } = Oidcc.ProviderConfiguration.Worker . start_link ( %{ issuer : &quot;https://accounts.google.com/&quot; , name : Myapp.OidccConfigProvider } ) via Supervisor Supervisor . init ( [ { Oidcc.ProviderConfiguration.Worker , %{ issuer : &quot;https://accounts.google.com&quot; , name : Myapp.OidccConfigProvider } } ] , strategy : :one_for_one )","ref":"readme.html#setup"},{"type":"extras","title":"oidcc - Usage","doc":"Companion libraries oidcc offers integrations for various libraries: oidcc_plug - Integrations for plug and phoenix &lt;!-- - phx_gen_oidcc - Setup Generator for phoenix --&gt; Erlang %% Create redirect URI for authorization { ok , RedirectUri } = oidcc : create_redirect_url ( myapp_oidcc_config_provider , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; \#{ redirect_uri : &lt;&lt; &quot;https://example.com/callback&quot; } ) , %% Redirect user to `RedirectUri` %% Retrieve `code` query / form param from redirect back %% Exchange code for token { ok , Token } = oidcc : retrieve_token ( AuthCode , myapp_oidcc_config_provider , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ redirect_uri =&gt; &lt;&lt; &quot;https://example.com/callback&quot; &gt;&gt; } ) , %% Load userinfo for token { ok , Claims } = oidcc : retrieve_userinfo ( Token , myapp_oidcc_config_provider , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ } ) , %% Load introspection for access token { ok , Introspection } = oidcc : introspect_token ( Token , myapp_oidcc_config_provider , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ } ) , %% Refresh token when it expires { ok , RefreshedToken } = oidcc : refresh_token ( Token , myapp_oidcc_config_provider , &lt;&lt; &quot;client_id&quot; &gt;&gt; , &lt;&lt; &quot;client_secret&quot; &gt;&gt; , \#{ } ) . for more details, see https://hexdocs.pm/oidcc/oidcc.html Elixir # Create redirect URI for authorization { :ok , redirect_uri } = Oidcc . create_redirect_url ( Myapp.OidccConfigProvider , &quot;client_id&quot; , &quot;client_secret&quot; , %{ redirect_uri : &quot;https://example.com/callback&quot; } ) # Redirect user to `redirect_uri` # Retrieve `code` query / form param from redirect back # Exchange code for token { :ok , token } = Oidcc . retrieve_token ( auth_code , Myapp.OidccConfigProvider , &quot;client_id&quot; , &quot;client_secret&quot; , %{ redirect_uri : &quot;https://example.com/callback&quot; } ) # Load userinfo for token { :ok , Claims } = Oidcc . retrieve_userinfo ( token , Myapp.OidccConfigProvider , &quot;client_id&quot; , &quot;client_secret&quot; , %{ expected_subject : &quot;sub&quot; } ) # Load introspection for access token { :ok , introspection } = Oidcc . introspect_token ( token , Myapp.OidccConfigProvider , &quot;client_id&quot; , &quot;client_secret&quot; ) # Refresh token when it expires { :ok , refreshed_token } = Oidcc . refresh_token ( token , Myapp.OidccConfigProvider , &quot;client_id&quot; , &quot;client_secret&quot; ) for more details, see https://hexdocs.pm/oidcc/Oidcc.html","ref":"readme.html#usage"}]